/*
 *  Copyright (C) 2018 Wouter Kumeling
 *
 *  This file is part of Agent Dialogues
 *
 *  Agent Dialogues is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This source code is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with this source code; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package agentstestjava.blackargument

import net.sf.tweety.arg.delp.DefeasibleLogicProgram
import net.sf.tweety.arg.delp.semantics.ComparisonCriterion
import net.sf.tweety.arg.delp.syntax.DelpArgument
import net.sf.tweety.arg.delp.syntax.DelpFact
import net.sf.tweety.logics.commons.syntax.Predicate
import net.sf.tweety.logics.fol.syntax.FOLAtom
import java.util.*

interface IBetterDiacTree {

    /**
     * The parent node; <source></source>null if this node is a root
     */
    val parent: IBetterDiacTree?
    /**
     * The argument in this node
     */
    val argument: DelpArgument
    /**
     * The children of this node; size=0 indicates a leaf
     */
    val children: MutableSet<IBetterDiacTree>
    /**
     * Returns the argumentation line which is generated by the path from this node to the root (in reverse)
     *
     * @return a stream of arguments denoting the argumentation line
     */
    val argumentationLine: List<DelpArgument>
        get() = (parent?.argumentationLine ?: emptyList()) + this.argument
    /**
     * Computes the marking of this node by considering the marking of all child nodes
     *
     * @return one of DialecticalTree.MARK_DEFEATED and DialecticalTree.MARK_UNDEFEATED
     */
    val marking: IBetterDiacTree.Mark
        get() {
            for (child in children) {
                if (child.marking == IBetterDiacTree.Mark.UNDEFEATED) {
                    return Mark.DEFEATED
                }
            }

            return Mark.UNDEFEATED
        }

    /**
     * Computes the set of arguments which are defeaters for the argument in this tree node and returns
     * the corresponding dialectical tree nodes with these defeaters. For the computation of the defeaters
     * the whole argumentation line to this tree node is considered. As a side effect the computed tree nodes
     * are added as children of this node. The set of children is cleared first if desired. Also, optionally, all
     * arguments ever moved can be considered.
     *
     * @param arguments           a set of arguments
     * @param delp                a defeasible logic program
     * @param comparisonCriterion a comparison criterion.
     * @param addAsChild          whether to add new nodes to the tree.
     * @param getArgumentsFromDlpToo whether to also get the arguments from [delp]
     * @return the set of new defeater nodes of the argument in this node
     */
    open fun getNewDefeaters(arguments: Set<DelpArgument> = emptySet(),
                             delp: DefeasibleLogicProgram,
                             comparisonCriterion: ComparisonCriterion,
                             addAsChild: Boolean,
                             getArgumentsFromDlpToo: Boolean = false): Set<IBetterDiacTree>

    /**
     * Checks whether the argumentation line composed of the ancestors of this node and the parameter
     * <source></source>argument is acceptable given the parameter <source></source>delp
     *
     * @param argument            a DeLP argument
     * @param delp                a defeasible logic program
     * @param comparisonCriterion a comparison criterion.
     * @return <source></source>true if the corresponding argumentation line is acceptable
     */
    fun isAcceptable(argument: DelpArgument,
                     delp: DefeasibleLogicProgram,
                     comparisonCriterion: ComparisonCriterion): Boolean {

        //Subargument test: return FALSE if any subargument found
        if (argumentationLine.any { argument.isSubargumentOf(it) }) {
            return false
        }

        //Concordance
        val rules = HashSet(argument.support)
        // collect every other element in argumentation line
        // beginning from the second last element (one before root):
        var i = argumentationLine.size - 2
        while (i >= 0) {
            rules.addAll(argumentationLine[i].support)
            i -= 2
        }

        if (!delp.isConsistent(rules)) {
            return false
        }

        delp.add(DelpFact(FOLAtom(Predicate("TRUE"))))


        val disagreementSubargument = argumentationLine[argumentationLine.size - 1].getDisagreementSubargument(argument.conclusion, delp)
        if (comparisonCriterion.compare(argument, disagreementSubargument, delp) == ComparisonCriterion.Result.IS_WORSE) {
            return false
        }

        //Proper attack
        if (argumentationLine.size > 1) {
            val arg1 = argumentationLine[argumentationLine.size - 1]
            val arg2 = argumentationLine[argumentationLine.size - 2].getDisagreementSubargument(arg1.conclusion, delp)
            if (comparisonCriterion.compare(arg1, arg2, delp) == ComparisonCriterion.Result.NOT_COMPARABLE)
                if (comparisonCriterion.compare(argument, disagreementSubargument, delp) != ComparisonCriterion.Result.IS_BETTER)
                    return false
        }
        return true
    }

    override fun toString(): String

    override fun equals(other: Any?): Boolean

    override fun hashCode(): Int

    //Misc Methods

    enum class Mark {
        DEFEATED,
        UNDEFEATED;

        override fun toString(): String {
            return name.substring(0, 1) // first character as String
        }
    }
}